#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_ChannelLaunch.h"
#include "FileEncrypt.h"
std::auto_ptr<M_ChannelLaunch> M_ChannelLaunch::msSingleton(nullptr);

int M_ChannelLaunch::GetCount()
{
	return (int)mMapData.size();
}

const M_ChannelLaunchData* M_ChannelLaunch::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_ChannelLaunchData>& M_ChannelLaunch::GetMapData()
{
	return mMapData;
}

void M_ChannelLaunch::Reload()
{
	mMapData.clear();
	Load();
}

void M_ChannelLaunch::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ChannelLaunchData data;
		data.mID = element->IntAttribute("ID");
		data.mChannel = element->IntAttribute("Channel");
		data.mLevel = element->IntAttribute("Level");
		data.mName = element->Attribute("Name");
		data.mType = element->IntAttribute("Type");
		data.mReward1 = element->IntAttribute("Reward1");
		data.mReward2 = element->FloatAttribute("Reward2");
		data.mRankingList = element->IntAttribute("RankingList");
		data.mQuota = element->IntAttribute("Quota");
		data.mLeaderboardRewards = element->IntAttribute("LeaderboardRewards");
		data.mIssueNumber = element->IntAttribute("IssueNumber");
		data.mPlayerType = element->IntAttribute("PlayerType");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void M_ChannelLaunch::Load()
{
	Load("../Config/M_ChannelLaunch.xml");
}

M_ChannelLaunch* M_ChannelLaunch::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ChannelLaunch());
	}
	return msSingleton.get();
}
